﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ExceptionHandlingBestPractices
{
    class Program
    {
        static void Main(string[] args)
        {
            SimpleClient sc = new SimpleClient();
            try
            {
                int z = sc.DivideByZero();
            }
            catch (MyCustomException myCustomEx)
            {
                Console.WriteLine(myCustomEx.Message);
                Console.Write(myCustomEx.InnerException.ToString());
            }
        }
    }
 
    class SimpleClient
    {
        public int DivideByZero()
        {
            int x = 4;
            int y = 0;
            int z = 0;
            try
            {
                z = x / y;
            }
            catch (Exception e)
            {
                throw new MyCustomException("Custom Error Message", e);
            }
            return z;
        }
    }
}
